Namespace MvcSalesApp.SharedKernel
  'there is actually a CookieContainer API in .NET but I'm leaving this part as demo-ware

  Public Class CookieUtilities
	Public Shared Function BuildCartCookie(ByVal createdCartCookie As String, ByVal cartCookieExpires As Date) As HttpCookie
	  Dim cartCookie = New HttpCookie("PluralsightEF6ShoppingCartDemo_Cart")
	  cartCookie.Value = createdCartCookie
	  cartCookie.Expires = cartCookieExpires
	  Return cartCookie
	End Function

	Public Shared Function CreateCookie(ByVal expiresDateTime As Date) As String
	  Return $"cName=SalesAppCookie|cGuid={Guid.NewGuid()}|cExpires={expiresDateTime.ToUniversalTime}"
	End Function

	Public Shared Function IsCartCookie(ByVal cookie As String) As Boolean
	  Dim crumbs = cookie.Split(Convert.ToChar("|"))
	  If crumbs(0) <> "cName=SalesAppCookie" Then
		  Return False
	  End If
	  If Not crumbs(1).StartsWith("cGuid=") Then
		  Return False
	  End If
	  Dim guidCheck = crumbs(1).Substring("cGuid=".Length + 1)
	  Dim guidResult As Guid
	  If Not Guid.TryParse(guidCheck, guidResult) Then
		  Return False
	  End If
	  If Not crumbs(2).StartsWith("cExpires=") Then
		  Return False
	  End If
	  Return True
	End Function

	'{
	'  StringBuilder sb = new StringBuilder();
	'  // Get cookie from the current request.
	'  HttpCookie cookie = Request.Cookies.Get("DateCookieExample");

	'  // Check if cookie exists in the current request.
	'  if (cookie == null) {
	'    sb.Append("Cookie was not received from the client. ");
	'    sb.Append("Creating cookie to add to the response. <br/>");
	'    // Create cookie.
	'    cookie = new HttpCookie("DateCookieExample");
	'    // Set value of cookie to current date time.
	'    cookie.Value = DateTime.Now.ToString;
	'    // Set cookie to expire in 10 minutes.
	'    cookie.Expires = DateTime.Now.AddMinutes(10d);
	'    // Insert the cookie in the current HttpResponse.
	'    Response.Cookies.Add(cookie);
	'  }
	'  else {
	'    sb.Append("Cookie retrieved from client. <br/>");
	'    sb.Append("Cookie Name: " + cookie.Name + "<br/>");
	'    sb.Append("Cookie Value: " + cookie.Value + "<br/>");
	'    sb.Append("Cookie Expiration Date: " +
	'        cookie.Expires.ToString + "<br/>");
	'  }
	'  Label1.Text = sb.ToString;
	'}
  End Class
End Namespace
