Imports MvcSalesApp.SharedKernel
Imports Order.Domain.ValueObjects

Namespace Order.Read.Domain
  Public Class SalesOrder
	  Inherits Entity

	Protected Sub New()
	  LineItems = New List(Of LineItem)
	End Sub

	Private privateOrderDate As Date
	Public Property OrderDate As Date
		Get
			Return privateOrderDate
		End Get
		Private Set(ByVal value As Date)
			privateOrderDate = value
		End Set
	End Property

	Private privateDueDate? As Date
	Public Property DueDate As Date?
		Get
			Return privateDueDate
		End Get
		Private Set(ByVal value? As Date)
			privateDueDate = value
		End Set
	End Property

	Private privateOnlineOrder As Boolean
	Public Property OnlineOrder As Boolean
		Get
			Return privateOnlineOrder
		End Get
		Private Set(ByVal value As Boolean)
			privateOnlineOrder = value
		End Set
	End Property

	Private privatePurchaseOrderNumber As String
	Public Property PurchaseOrderNumber As String
		Get
			Return privatePurchaseOrderNumber
		End Get
		Private Set(ByVal value As String)
			privatePurchaseOrderNumber = value
		End Set
	End Property

	Private privateComment As String
	Public Property Comment As String
		Get
			Return privateComment
		End Get
		Private Set(ByVal value As String)
			privateComment = value
		End Set
	End Property

	Private privatePromotionId As Integer
	Public Property PromotionId As Integer
		Get
			Return privatePromotionId
		End Get
		Private Set(ByVal value As Integer)
			privatePromotionId = value
		End Set
	End Property

	Private privateShippingAddress As Address
	Public Property ShippingAddress As Address
		Get
			Return privateShippingAddress
		End Get
		Private Set(ByVal value As Address)
			privateShippingAddress = value
		End Set
	End Property

	Private privateCurrentCustomerStatus As CustomerStatus
	Public Property CurrentCustomerStatus As CustomerStatus
		Get
			Return privateCurrentCustomerStatus
		End Get
		Private Set(ByVal value As CustomerStatus)
			privateCurrentCustomerStatus = value
		End Set
	End Property

	Public ReadOnly Property Discount As Double
	  Get
		  Return CustomerDiscount + PromoDiscount
	  End Get
	End Property

	Private privateCustomerDiscount As Double
	Public Property CustomerDiscount As Double
		Get
			Return privateCustomerDiscount
		End Get
		Private Set(ByVal value As Double)
			privateCustomerDiscount = value
		End Set
	End Property

	Private privatePromoDiscount As Double
	Public Property PromoDiscount As Double
		Get
			Return privatePromoDiscount
		End Get
		Private Set(ByVal value As Double)
			privatePromoDiscount = value
		End Set
	End Property

	Private privateSalesOrderNumber As String
	Public Property SalesOrderNumber As String
		Get
			Return privateSalesOrderNumber
		End Get
		Private Set(ByVal value As String)
			privateSalesOrderNumber = value
		End Set
	End Property

	Private privateCustomerId As Integer
	Public Property CustomerId As Integer
		Get
			Return privateCustomerId
		End Get
		Private Set(ByVal value As Integer)
			privateCustomerId = value
		End Set
	End Property

	Private privateSubTotal As Double
	Public Property SubTotal As Double
		Get
			Return privateSubTotal
		End Get
		Private Set(ByVal value As Double)
			privateSubTotal = value
		End Set
	End Property

	Private privateLineItems As ICollection(Of LineItem)
	Public Property LineItems As ICollection(Of LineItem)
		Get
			Return privateLineItems
		End Get
		Private Set(ByVal value As ICollection(Of LineItem))
			privateLineItems = value
		End Set
	End Property

	Public Sub SetShippingAddress(ByVal address As Address)
	  ShippingAddress = Address.Create(address.Street, address.City, address.StateProvince, address.PostalCode)
	End Sub

	Public Function CalculateShippingCost() As Decimal
	  'items, quantity, price,disounts, total weight of item
	  'this is the job of a microservice we can call out to
	  Throw New NotImplementedException
	End Function
  End Class
End Namespace
