Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports Moq
Imports Order.Read.Data
Imports Order.Read.Domain
Imports System.Data.Entity
Imports System.Linq

Namespace Order.Read.Tests
  <TestClass>
  Public Class UnitTest1
	<TestMethod>
	Public Sub CanQueryDataFromReadModel()
	  'arrange --.
	  Dim scContext = New OrderReadContext With {.Orders = MockedDbSet(Of SalesOrder)(Nothing)}
	  Dim readmodel = New ReadModel

	  'act and assert
	  Assert.IsInstanceOfType(readmodel.Orders.ToList, GetType(List(Of SalesOrder)))
	End Sub

	Private Shared Function MockedDbSet(Of T As Class)(ByVal inMemoryEntities As ICollection(Of T)) As DbSet(Of T)
	  If inMemoryEntities Is Nothing Then
		inMemoryEntities = New List(Of T)
	  End If
	  Dim queryableData = inMemoryEntities.AsQueryable
            Dim mockedDbSet_Renamed = New Mock(Of DbSet(Of T))()
            mockedDbSet_Renamed.Setup(Function(m) m.Add(It.IsAny(Of T)()))
            mockedDbSet_Renamed.As(Of IQueryable(Of T))().Setup(Function(m) m.Provider).Returns(queryableData.Provider)
	  mockedDbSet_Renamed.As(Of IQueryable(Of T))().Setup(Function(m) m.Expression).Returns(queryableData.Expression)
	  mockedDbSet_Renamed.As(Of IQueryable(Of T))().Setup(Function(m) m.ElementType).Returns(queryableData.ElementType)
	  mockedDbSet_Renamed.As(Of IQueryable(Of T))().Setup(Function(m) m.GetEnumerator).Returns(queryableData.GetEnumerator)
	  mockedDbSet_Renamed.Setup(Function(x) x.AsNoTracking).Returns(mockedDbSet_Renamed.Object)

	  Return mockedDbSet_Renamed.Object
	End Function
  End Class
End Namespace
