Imports System.Data.Entity
Imports Order.Read.Domain

Namespace Order.Write.Data
  Public Class OrderWriteContext
	  Inherits DbContext

	Public Sub New()
		MyBase.New("name=GeekStuffSales")
	End Sub

	Public Property Orders As DbSet(Of SalesOrder)

	Public Property LineItems As DbSet(Of LineItem)

	Protected Overrides Sub OnModelCreating(ByVal modelBuilder As DbModelBuilder)
	  modelBuilder.HasDefaultSchema("Order")
	  modelBuilder.Entity(Of SalesOrder)().Ignore(Function(s) s.LineItems)
	End Sub
  End Class

  Public Class OrderSystemContextConfig
	  Inherits DbConfiguration

	Public Sub New()
	  SetDatabaseInitializer(New NullDatabaseInitializer(Of OrderWriteContext))
	End Sub
  End Class
End Namespace
