Imports Order.Domain.ValueObjects

Namespace Order.Write.Domain.DTOs
  Public Class Customer
	Private Sub New(ByVal customerId As Integer, ByVal primaryAddress As Address, ByVal status As CustomerStatus)
	  Me.CustomerId = customerId
	  Me.PrimaryAddress = primaryAddress
	  Me.Status = CustomerStatus.New
	End Sub

	Private privateCustomerId As Integer
	Public Property CustomerId As Integer
		Get
			Return privateCustomerId
		End Get
		Private Set(ByVal value As Integer)
			privateCustomerId = value
		End Set
	End Property

	Private privateStatus As CustomerStatus
	Public Property Status As CustomerStatus
		Get
			Return privateStatus
		End Get
		Private Set(ByVal value As CustomerStatus)
			privateStatus = value
		End Set
	End Property

	Private privatePrimaryAddress As Address
	Public Property PrimaryAddress As Address
		Get
			Return privatePrimaryAddress
		End Get
		Private Set(ByVal value As Address)
			privatePrimaryAddress = value
		End Set
	End Property

	Public Shared Function Create(ByVal customerId As Integer, ByVal primaryAddress As Address, ByVal status As CustomerStatus) As Customer
	  Dim customer = New Customer(customerId, primaryAddress, status)
	  customer.PrimaryAddress = primaryAddress
	  Return customer
	End Function
  End Class
End Namespace
