Imports MvcSalesApp.SharedKernel

Namespace Order.Write.Domain
  Public Class LineItem
	  Inherits Entity

	Public Shared Function Create(ByVal orderId As Guid, ByVal productId As Integer, ByVal quantity As Integer, ByVal unitPrice As Double, ByVal unitPriceDiscount As Double) As LineItem
	  Return New LineItem(orderId, productId, quantity, unitPrice, unitPriceDiscount)
	End Function

	Private Sub New(ByVal orderId As Guid, ByVal productId As Integer, ByVal quantity As Integer, ByVal unitPrice As Double, ByVal unitPriceDiscount As Double)
	  Id = Guid.NewGuid
	  SalesOrderId = orderId
	  Me.Quantity = quantity
	  Me.ProductId = productId
	  Me.UnitPrice = unitPrice
	  Me.UnitPriceDiscount = unitPriceDiscount
	End Sub

	'private LineItem() {
	'}

	Private privateSalesOrderId As Guid
	Public Property SalesOrderId As Guid
		Get
			Return privateSalesOrderId
		End Get
		Private Set(ByVal value As Guid)
			privateSalesOrderId = value
		End Set
	End Property

	Private privateProductId As Integer
	Public Property ProductId As Integer
		Get
			Return privateProductId
		End Get
		Private Set(ByVal value As Integer)
			privateProductId = value
		End Set
	End Property

	Private privateQuantity As Integer
	Public Property Quantity As Integer
		Get
			Return privateQuantity
		End Get
		Private Set(ByVal value As Integer)
			privateQuantity = value
		End Set
	End Property

	Private privateUnitPrice? As Double
	Public Property UnitPrice As Double?
		Get
			Return privateUnitPrice
		End Get
		Private Set(ByVal value? As Double)
			privateUnitPrice = value
		End Set
	End Property

	Private privateUnitPriceDiscount? As Double
	Public Property UnitPriceDiscount As Double?
		Get
			Return privateUnitPriceDiscount
		End Get
		Private Set(ByVal value? As Double)
			privateUnitPriceDiscount = value
		End Set
	End Property

	Public ReadOnly Property LineTotal As Double
	  Get
		If UnitPrice IsNot Nothing Then
		  If UnitPriceDiscount IsNot Nothing Then
			Return Quantity * (UnitPrice.Value * (1 - UnitPriceDiscount.Value))
		  End If
		End If
		Return 0
	  End Get
	End Property

	Public Property ShipmentId As Integer?

	Public Sub AdjustQuantity(ByVal quantity As Integer)
	  Me.Quantity = quantity
	End Sub
  End Class
End Namespace
