Imports MvcSalesApp.SharedKernel

Namespace Order.Domain.ValueObjects
  Public Class Address
	  Inherits ValueObject(Of Address)

	Public Shared Function Create(ByVal street As String, ByVal city As String, ByVal stateProvince As String, ByVal postalCode As String) As Address
	  Return New Address(street, city, stateProvince, postalCode)
	End Function

	  Private Sub New(ByVal street As String, ByVal city As String, ByVal stateProvince As String, ByVal postalCode As String)
	  Me.Street = street
	  Me.City = city
	  Me.StateProvince = stateProvince
	  Me.PostalCode = postalCode
	  End Sub

	Public Sub New() 'need for EF queries
	End Sub

	Private privateStreet As String
	Public Property Street As String
		Get
			Return privateStreet
		End Get
		Private Set(ByVal value As String)
			privateStreet = value
		End Set
	End Property

	Private privateCity As String
	Public Property City As String
		Get
			Return privateCity
		End Get
		Private Set(ByVal value As String)
			privateCity = value
		End Set
	End Property

	Private privateStateProvince As String
	Public Property StateProvince As String
		Get
			Return privateStateProvince
		End Get
		Private Set(ByVal value As String)
			privateStateProvince = value
		End Set
	End Property

	Private privatePostalCode As String
	Public Property PostalCode As String
		Get
			Return privatePostalCode
		End Get
		Private Set(ByVal value As String)
			privatePostalCode = value
		End Set
	End Property
  End Class
End Namespace
